/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// TargetProductSchema The reference object to the schema and type of target product which is described by product specification
type TargetProductSchema struct {
	// When sub-classing, this defines the super-class
	BaseType *string `json:"@baseType,omitempty"`
	// This field provides a link to the schema describing the target product
	SchemaLocation string `json:"@schemaLocation"`
	// Class type of the target product
	Type string `json:"@type"`
}

// NewTargetProductSchema instantiates a new TargetProductSchema object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTargetProductSchema(schemaLocation string, type_ string, ) *TargetProductSchema {
	this := TargetProductSchema{}
	this.SchemaLocation = schemaLocation
	this.Type = type_
	return &this
}

// NewTargetProductSchemaWithDefaults instantiates a new TargetProductSchema object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTargetProductSchemaWithDefaults() *TargetProductSchema {
	this := TargetProductSchema{}
	return &this
}

// GetBaseType returns the BaseType field value if set, zero value otherwise.
func (o *TargetProductSchema) GetBaseType() string {
	if o == nil || o.BaseType == nil {
		var ret string
		return ret
	}
	return *o.BaseType
}

// GetBaseTypeOk returns a tuple with the BaseType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TargetProductSchema) GetBaseTypeOk() (*string, bool) {
	if o == nil || o.BaseType == nil {
		return nil, false
	}
	return o.BaseType, true
}

// HasBaseType returns a boolean if a field has been set.
func (o *TargetProductSchema) HasBaseType() bool {
	if o != nil && o.BaseType != nil {
		return true
	}

	return false
}

// SetBaseType gets a reference to the given string and assigns it to the BaseType field.
func (o *TargetProductSchema) SetBaseType(v string) {
	o.BaseType = &v
}

// GetSchemaLocation returns the SchemaLocation field value
func (o *TargetProductSchema) GetSchemaLocation() string {
	if o == nil  {
		var ret string
		return ret
	}

	return o.SchemaLocation
}

// GetSchemaLocationOk returns a tuple with the SchemaLocation field value
// and a boolean to check if the value has been set.
func (o *TargetProductSchema) GetSchemaLocationOk() (*string, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.SchemaLocation, true
}

// SetSchemaLocation sets field value
func (o *TargetProductSchema) SetSchemaLocation(v string) {
	o.SchemaLocation = v
}

// GetType returns the Type field value
func (o *TargetProductSchema) GetType() string {
	if o == nil  {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *TargetProductSchema) GetTypeOk() (*string, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *TargetProductSchema) SetType(v string) {
	o.Type = v
}

func (o TargetProductSchema) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.BaseType != nil {
		toSerialize["@baseType"] = o.BaseType
	}
	if true {
		toSerialize["@schemaLocation"] = o.SchemaLocation
	}
	if true {
		toSerialize["@type"] = o.Type
	}
	return json.Marshal(toSerialize)
}

type NullableTargetProductSchema struct {
	value *TargetProductSchema
	isSet bool
}

func (v NullableTargetProductSchema) Get() *TargetProductSchema {
	return v.value
}

func (v *NullableTargetProductSchema) Set(val *TargetProductSchema) {
	v.value = val
	v.isSet = true
}

func (v NullableTargetProductSchema) IsSet() bool {
	return v.isSet
}

func (v *NullableTargetProductSchema) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTargetProductSchema(val *TargetProductSchema) *NullableTargetProductSchema {
	return &NullableTargetProductSchema{value: val, isSet: true}
}

func (v NullableTargetProductSchema) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTargetProductSchema) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


